// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;


/** @dll.struct() */
public class FILETIME {
    public int dwLowDateTime;
    public int dwHighDateTime;

    public FILETIME()
    {
    }

    public FILETIME( int dwLowDateTime, int dwHighDateTime )
    {
        this.dwLowDateTime = dwLowDateTime;
        this.dwHighDateTime = dwHighDateTime;
    }

    public FILETIME( long lTime )
    {
        dwLowDateTime = (int)(lTime);
        dwHighDateTime = (int)(lTime >> 32);
    }

    public long getTimeLong()
    {
        return( (((long)dwHighDateTime) << 32) |
                    (((long)dwLowDateTime) & 0xFFFFFFFFL) );
    }
}

