// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;


/**
 * TV_ITEM_T corresponds to a Win32 TVITEM structure.
 * This class is useful only for modifying a tree view item's attributes via
 * Windows message TVM_SETITEM.  It should not be used for querying a tree
 * view item's attributes via TVM_GETITEM, as the pszText field may be invalid.
 */

/** @dll.struct(pack=1, auto) */
public class TV_ITEM_T
{
    public int      mask;
    public int      hItem;
    public int      state;
    public int      stateMask;
    public String   pszText;
    public int      cchTextMax;
    public int      iImage;
    public int      iSelectedImage;
    public int      cChildren;
    public int      lParam;
}

