// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface oleacc {

    // PROPERTIES:  Hierarchical
    public static final int DISPID_ACC_PARENT                   = (-5000);
    public static final int DISPID_ACC_CHILDCOUNT               = (-5001);
    public static final int DISPID_ACC_CHILD                    = (-5002);

    // PROPERTIES:  Descriptional
    public static final int DISPID_ACC_NAME                     = (-5003);
    public static final int DISPID_ACC_VALUE                    = (-5004);
    public static final int DISPID_ACC_DESCRIPTION              = (-5005);
    public static final int DISPID_ACC_ROLE                     = (-5006);
    public static final int DISPID_ACC_STATE                    = (-5007);
    public static final int DISPID_ACC_HELP                     = (-5008);
    public static final int DISPID_ACC_HELPTOPIC                = (-5009);
    public static final int DISPID_ACC_KEYBOARDSHORTCUT         = (-5010);
    public static final int DISPID_ACC_FOCUS                    = (-5011);
    public static final int DISPID_ACC_SELECTION                = (-5012);
    public static final int DISPID_ACC_DEFAULTACTION            = (-5013);

    // METHODS
    public static final int DISPID_ACC_SELECT                   = (-5014);
    public static final int DISPID_ACC_LOCATION                 = (-5015);
    public static final int DISPID_ACC_NAVIGATE                 = (-5016);
    public static final int DISPID_ACC_HITTEST                  = (-5017);
    public static final int DISPID_ACC_DODEFAULTACTION          = (-5018);

    //
    // Input to DISPID_ACC_NAVIGATE
    //
    public static final int NAVDIR_MIN                      = 0x00000000;
    public static final int NAVDIR_UP                       = 0x00000001;
    public static final int NAVDIR_DOWN                     = 0x00000002;
    public static final int NAVDIR_LEFT                     = 0x00000003;
    public static final int NAVDIR_RIGHT                    = 0x00000004;
    public static final int NAVDIR_NEXT                     = 0x00000005;
    public static final int NAVDIR_PREVIOUS                 = 0x00000006;
    public static final int NAVDIR_FIRSTCHILD               = 0x00000007;
    public static final int NAVDIR_LASTCHILD                = 0x00000008;
    public static final int NAVDIR_MAX                      = 0x00000009;

    // Input to DISPID_ACC_SELECT
    public static final int SELFLAG_NONE                    = 0x00000000;
    public static final int SELFLAG_TAKEFOCUS               = 0x00000001;
    public static final int SELFLAG_TAKESELECTION           = 0x00000002;
    public static final int SELFLAG_EXTENDSELECTION         = 0x00000004;
    public static final int SELFLAG_ADDSELECTION            = 0x00000008;
    public static final int SELFLAG_REMOVESELECTION         = 0x00000010;
    public static final int SELFLAG_VALID                   = 0x0000001F;

    // Output from DISPID_ACC_STATE
    public static final int STATE_SYSTEM_UNAVAILABLE        = 0x00000001;  // Disabled
    public static final int STATE_SYSTEM_SELECTED           = 0x00000002;
    public static final int STATE_SYSTEM_FOCUSED            = 0x00000004;
    public static final int STATE_SYSTEM_PRESSED            = 0x00000008;
    public static final int STATE_SYSTEM_CHECKED            = 0x00000010;
    public static final int STATE_SYSTEM_MIXED              = 0x00000020;  // 3-state checkbox or toolbar button
    public static final int STATE_SYSTEM_READONLY           = 0x00000040;
    public static final int STATE_SYSTEM_HOTTRACKED         = 0x00000080;
    public static final int STATE_SYSTEM_DEFAULT            = 0x00000100;
    public static final int STATE_SYSTEM_EXPANDED           = 0x00000200;
    public static final int STATE_SYSTEM_COLLAPSED          = 0x00000400;
    public static final int STATE_SYSTEM_BUSY               = 0x00000800;
    public static final int STATE_SYSTEM_FLOATING           = 0x00001000;  // Children "owned" not "contained" by parent
    public static final int STATE_SYSTEM_MARQUEED           = 0x00002000;
    public static final int STATE_SYSTEM_ANIMATED           = 0x00004000;
    public static final int STATE_SYSTEM_INVISIBLE          = 0x00008000;
    public static final int STATE_SYSTEM_OFFSCREEN          = 0x00010000;
    public static final int STATE_SYSTEM_SIZEABLE           = 0x00020000;
    public static final int STATE_SYSTEM_MOVEABLE           = 0x00040000;
    public static final int STATE_SYSTEM_SELFVOICING        = 0x00080000;
    public static final int STATE_SYSTEM_FOCUSABLE          = 0x00100000;
    public static final int STATE_SYSTEM_SELECTABLE         = 0x00200000;
    public static final int STATE_SYSTEM_LINKED             = 0x00400000;
    public static final int STATE_SYSTEM_TRAVERSED          = 0x00800000;
    public static final int STATE_SYSTEM_MULTISELECTABLE    = 0x01000000;  // Supports multiple selection
    public static final int STATE_SYSTEM_EXTSELECTABLE      = 0x02000000;  // Supports extended selection
    public static final int STATE_SYSTEM_ALERT_LOW          = 0x04000000;  // This information is of low priority
    public static final int STATE_SYSTEM_ALERT_MEDIUM       = 0x08000000;  // This information is of medium priority
    public static final int STATE_SYSTEM_ALERT_HIGH         = 0x10000000;  // This information is of high priority
    public static final int STATE_SYSTEM_VALID              = 0x1FFFFFFF;

    // Output from DISPID_ACC_ROLE
    public static final int ROLE_SYSTEM_TITLEBAR            = 0x00000001;
    public static final int ROLE_SYSTEM_MENUBAR             = 0x00000002;
    public static final int ROLE_SYSTEM_SCROLLBAR           = 0x00000003;
    public static final int ROLE_SYSTEM_GRIP                = 0x00000004;
    public static final int ROLE_SYSTEM_SOUND               = 0x00000005;
    public static final int ROLE_SYSTEM_CURSOR              = 0x00000006;
    public static final int ROLE_SYSTEM_CARET               = 0x00000007;
    public static final int ROLE_SYSTEM_ALERT               = 0x00000008;
    public static final int ROLE_SYSTEM_WINDOW              = 0x00000009;
    public static final int ROLE_SYSTEM_CLIENT              = 0x0000000A;
    public static final int ROLE_SYSTEM_MENUPOPUP           = 0x0000000B;
    public static final int ROLE_SYSTEM_MENUITEM            = 0x0000000C;
    public static final int ROLE_SYSTEM_TOOLTIP             = 0x0000000D;
    public static final int ROLE_SYSTEM_APPLICATION         = 0x0000000E;
    public static final int ROLE_SYSTEM_DOCUMENT            = 0x0000000F;
    public static final int ROLE_SYSTEM_PANE                = 0x00000010;
    public static final int ROLE_SYSTEM_CHART               = 0x00000011;
    public static final int ROLE_SYSTEM_DIALOG              = 0x00000012;
    public static final int ROLE_SYSTEM_BORDER              = 0x00000013;
    public static final int ROLE_SYSTEM_GROUPING            = 0x00000014;
    public static final int ROLE_SYSTEM_SEPARATOR           = 0x00000015;
    public static final int ROLE_SYSTEM_TOOLBAR             = 0x00000016;
    public static final int ROLE_SYSTEM_STATUSBAR           = 0x00000017;
    public static final int ROLE_SYSTEM_TABLE               = 0x00000018;
    public static final int ROLE_SYSTEM_COLUMNHEADER        = 0x00000019;
    public static final int ROLE_SYSTEM_ROWHEADER           = 0x0000001A;
    public static final int ROLE_SYSTEM_COLUMN              = 0x0000001B;
    public static final int ROLE_SYSTEM_ROW                 = 0x0000001C;
    public static final int ROLE_SYSTEM_CELL                = 0x0000001D;
    public static final int ROLE_SYSTEM_LINK                = 0x0000001E;
    public static final int ROLE_SYSTEM_HELPBALLOON         = 0x0000001F;
    public static final int ROLE_SYSTEM_CHARACTER           = 0x00000020;
    public static final int ROLE_SYSTEM_LIST                = 0x00000021;
    public static final int ROLE_SYSTEM_LISTITEM            = 0x00000022;
    public static final int ROLE_SYSTEM_OUTLINE             = 0x00000023;
    public static final int ROLE_SYSTEM_OUTLINEITEM         = 0x00000024;
    public static final int ROLE_SYSTEM_PAGETAB             = 0x00000025;
    public static final int ROLE_SYSTEM_PROPERTYPAGE        = 0x00000026;
    public static final int ROLE_SYSTEM_INDICATOR           = 0x00000027;
    public static final int ROLE_SYSTEM_GRAPHIC             = 0x00000028;
    public static final int ROLE_SYSTEM_STATICTEXT          = 0x00000029;
    public static final int ROLE_SYSTEM_TEXT                = 0x0000002A;  // Editable, selectable, etc.
    public static final int ROLE_SYSTEM_PUSHBUTTON          = 0x0000002B;
    public static final int ROLE_SYSTEM_CHECKBUTTON         = 0x0000002C;
    public static final int ROLE_SYSTEM_RADIOBUTTON         = 0x0000002D;
    public static final int ROLE_SYSTEM_COMBOBOX            = 0x0000002E;
    public static final int ROLE_SYSTEM_DROPLIST            = 0x0000002F;
    public static final int ROLE_SYSTEM_PROGRESSBAR         = 0x00000030;
    public static final int ROLE_SYSTEM_DIAL                = 0x00000031;
    public static final int ROLE_SYSTEM_HOTKEYFIELD         = 0x00000032;
    public static final int ROLE_SYSTEM_SLIDER              = 0x00000033;
    public static final int ROLE_SYSTEM_SPINBUTTON          = 0x00000034;
    public static final int ROLE_SYSTEM_DIAGRAM             = 0x00000035;
    public static final int ROLE_SYSTEM_ANIMATION           = 0x00000036;
    public static final int ROLE_SYSTEM_EQUATION            = 0x00000037;
    public static final int ROLE_SYSTEM_BUTTONDROPDOWN      = 0x00000038;
    public static final int ROLE_SYSTEM_BUTTONMENU          = 0x00000039;
    public static final int ROLE_SYSTEM_BUTTONDROPDOWNGRID  = 0x0000003A;
    public static final int ROLE_SYSTEM_WHITESPACE          = 0x0000003B;
    public static final int ROLE_SYSTEM_PAGETABLIST         = 0x0000003C;
    public static final int ROLE_SYSTEM_CLOCK               = 0x0000003D;

    public static final int CHILDID_SELF        = 0;
    public static final int INDEXID_OBJECT      = 0;
    public static final int INDEXID_CONTAINER   = 0;

    /*
     * Reserved IDs for system objects
     */
    public static final int OBJID_WINDOW        = 0x00000000;
    public static final int OBJID_SYSMENU       = 0xFFFFFFFF;
    public static final int OBJID_TITLEBAR      = 0xFFFFFFFE;
    public static final int OBJID_MENU          = 0xFFFFFFFD;
    public static final int OBJID_CLIENT        = 0xFFFFFFFC;
    public static final int OBJID_VSCROLL       = 0xFFFFFFFB;
    public static final int OBJID_HSCROLL       = 0xFFFFFFFA;
    public static final int OBJID_SIZEGRIP      = 0xFFFFFFF9;
    public static final int OBJID_CARET         = 0xFFFFFFF8;
    public static final int OBJID_CURSOR        = 0xFFFFFFF7;
    public static final int OBJID_ALERT         = 0xFFFFFFF6;
    public static final int OBJID_SOUND         = 0xFFFFFFF5;

    public static final int EVENT_MIN           = 0x00000001;
    public static final int EVENT_MAX           = 0x7FFFFFFF;

    public static final int EVENT_SYSTEM_SOUND              = 0x0001;
    public static final int EVENT_SYSTEM_ALERT              = 0x0002;
    public static final int EVENT_SYSTEM_FOREGROUND         = 0x0003;
    public static final int EVENT_SYSTEM_MENUSTART          = 0x0004;
    public static final int EVENT_SYSTEM_MENUEND            = 0x0005;
    public static final int EVENT_SYSTEM_MENUPOPUPSTART     = 0x0006;
    public static final int EVENT_SYSTEM_MENUPOPUPEND       = 0x0007;
    public static final int EVENT_SYSTEM_CAPTURESTART       = 0x0008;
    public static final int EVENT_SYSTEM_CAPTUREEND         = 0x0009;
    public static final int EVENT_SYSTEM_MOVESIZESTART      = 0x000A;
    public static final int EVENT_SYSTEM_MOVESIZEEND        = 0x000B;
    public static final int EVENT_SYSTEM_CONTEXTHELPSTART   = 0x000C;
    public static final int EVENT_SYSTEM_CONTEXTHELPEND     = 0x000D;
    public static final int EVENT_SYSTEM_DRAGDROPSTART      = 0x000E;
    public static final int EVENT_SYSTEM_DRAGDROPEND        = 0x000F;
    public static final int EVENT_SYSTEM_DIALOGSTART        = 0x0010;
    public static final int EVENT_SYSTEM_DIALOGEND          = 0x0011;
    public static final int EVENT_SYSTEM_SCROLLINGSTART     = 0x0012;
    public static final int EVENT_SYSTEM_SCROLLINGEND       = 0x0013;
    public static final int EVENT_SYSTEM_SWITCHSTART        = 0x0014;
    public static final int EVENT_SYSTEM_SWITCHEND          = 0x0015;
    public static final int EVENT_SYSTEM_MINIMIZESTART      = 0x0016;
    public static final int EVENT_SYSTEM_MINIMIZEEND        = 0x0017;
    public static final int EVENT_OBJECT_CREATE                 = 0x8000;  // hwnd + ID + idChild is created item
    public static final int EVENT_OBJECT_DESTROY                = 0x8001;  // hwnd + ID + idChild is destroyed item
    public static final int EVENT_OBJECT_SHOW                   = 0x8002;  // hwnd + ID + idChild is shown item
    public static final int EVENT_OBJECT_HIDE                   = 0x8003;  // hwnd + ID + idChild is hidden item
    public static final int EVENT_OBJECT_REORDER                = 0x8004;  // hwnd + ID + idChild is parent of zordering children
    public static final int EVENT_OBJECT_FOCUS                  = 0x8005;  // hwnd + ID + idChild is focused item
    public static final int EVENT_OBJECT_SELECTION              = 0x8006;  // hwnd + ID + idChild is selected item (if only one), or idChild is OBJID_WINDOW if complex
    public static final int EVENT_OBJECT_SELECTIONADD           = 0x8007;  // hwnd + ID + idChild is item added
    public static final int EVENT_OBJECT_SELECTIONREMOVE        = 0x8008;  // hwnd + ID + idChild is item removed
    public static final int EVENT_OBJECT_SELECTIONWITHIN        = 0x8009;  // hwnd + ID + idChild is parent of changed selected items
    public static final int EVENT_OBJECT_STATECHANGE            = 0x800A;  // hwnd + ID + idChild is item w/ state change
    public static final int EVENT_OBJECT_LOCATIONCHANGE         = 0x800B;  // hwnd + ID + idChild is moved/sized item
    public static final int EVENT_OBJECT_NAMECHANGE             = 0x800C;  // hwnd + ID + idChild is item w/ name change
    public static final int EVENT_OBJECT_DESCRIPTIONCHANGE      = 0x800D;  // hwnd + ID + idChild is item w/ desc change
    public static final int EVENT_OBJECT_VALUECHANGE            = 0x800E;  // hwnd + ID + idChild is item w/ value change
    public static final int EVENT_OBJECT_PARENTCHANGE           = 0x800F;  // hwnd + ID + idChild is item w/ new parent
    public static final int EVENT_OBJECT_HELPCHANGE             = 0x8010;  // hwnd + ID + idChild is item w/ help change
    public static final int EVENT_OBJECT_DEFACTIONCHANGE        = 0x8011;  // hwnd + ID + idChild is item w/ def action change
    public static final int EVENT_OBJECT_ACCELERATORCHANGE      = 0x8012;  // hwnd + ID + idChild is item w/ keybd accel change
}
