// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface winp {
    int PDERR_PRINTERCODES = 0x1000,
        PDERR_SETUPFAILURE = 0x1001,
        PDERR_PARSEFAILURE = 0x1002,
        PDERR_RETDEFFAILURE = 0x1003,
        PDERR_LOADDRVFAILURE = 0x1004,
        PDERR_GETDEVMODEFAIL = 0x1005,
        PDERR_INITFAILURE = 0x1006,
        PDERR_NODEVICES = 0x1007,
        PDERR_NODEFAULTPRN = 0x1008,
        PDERR_DNDMMISMATCH = 0x1009,
        PDERR_CREATEICFAILURE = 0x100A,
        PDERR_PRINTERNOTFOUND = 0x100B,
        PDERR_DEFAULTDIFFERENT = 0x100C,
        PRINTER_FONTTYPE = 0x4000,
        PD_ALLPAGES = 0x00000000,
        PD_SELECTION = 0x00000001,
        PD_PAGENUMS = 0x00000002,
        PD_NOSELECTION = 0x00000004,
        PD_NOPAGENUMS = 0x00000008,
        PD_COLLATE = 0x00000010,
        PD_PRINTTOFILE = 0x00000020,
        PD_PRINTSETUP = 0x00000040,
        PD_NOWARNING = 0x00000080,
        PD_RETURNDC = 0x00000100,
        PD_RETURNIC = 0x00000200,
        PD_RETURNDEFAULT = 0x00000400,
        PD_SHOWHELP = 0x00000800,
        PD_ENABLEPRINTHOOK = 0x00001000,
        PD_ENABLESETUPHOOK = 0x00002000,
        PD_ENABLEPRINTTEMPLATE = 0x00004000,
        PD_ENABLESETUPTEMPLATE = 0x00008000,
        PD_ENABLEPRINTTEMPLATEHANDLE = 0x00010000,
        PD_ENABLESETUPTEMPLATEHANDLE = 0x00020000,
        PD_USEDEVMODECOPIES = 0x00040000,
        PD_USEDEVMODECOPIESANDCOLLATE = 0x00040000,
        PD_DISABLEPRINTTOFILE = 0x00080000,
        PD_HIDEPRINTTOFILE = 0x00100000,
        PD_NONETWORKBUTTON = 0x00200000,
        PSD_DEFAULTMINMARGINS = 0x00000000,
        PSD_INWININIINTLMEASURE = 0x00000000,
        PSD_MINMARGINS = 0x00000001,
        PSD_MARGINS = 0x00000002,
        PSD_INTHOUSANDTHSOFINCHES = 0x00000004,
        PSD_INHUNDREDTHSOFMILLIMETERS = 0x00000008,
        PSD_DISABLEMARGINS = 0x00000010,
        PSD_DISABLEPRINTER = 0x00000020,
        PSD_NOWARNING = 0x00000080,
        PSD_DISABLEORIENTATION = 0x00000100,
        PSD_RETURNDEFAULT = 0x00000400,
        PSD_DISABLEPAPER = 0x00000200,
        PSD_SHOWHELP = 0x00000800,
        PSD_ENABLEPAGESETUPHOOK = 0x00002000,
        PSD_ENABLEPAGESETUPTEMPLATE = 0x00008000,
        PSD_ENABLEPAGESETUPTEMPLATEHANDLE = 0x00020000,
        PSD_ENABLEPAGEPAINTHOOK = 0x00040000,
        PSD_DISABLEPAGEPAINTING = 0x00080000,
        PSD_NONETWORKBUTTON = 0x00200000,
        psh1 = 0x0400,
        psh2 = 0x0401,
        psh3 = 0x0402,
        psh4 = 0x0403,
        psh5 = 0x0404,
        psh6 = 0x0405,
        psh7 = 0x0406,
        psh8 = 0x0407,
        psh9 = 0x0408,
        psh10 = 0x0409,
        psh11 = 0x040a,
        psh12 = 0x040b,
        psh13 = 0x040c,
        psh14 = 0x040d,
        psh15 = 0x040e,
        pshHelp = 0x040e,
        psh16 = 0x040f,
        PRINTDLGORD = 1538,
        PRNSETUPDLGORD = 1539,
        PAGESETUPDLGORD = 1546,
        PARAMFLAG_NONE = (0),
        PARAMFLAG_FIN = (0x1),
        PARAMFLAG_FOUT = (0x2),
        PARAMFLAG_FLCID = (0x4),
        PARAMFLAG_FRETVAL = (0x8),
        PARAMFLAG_FOPT = (0x10),
        PARAMFLAG_FHASDEFAULT = (0x20),
        PROPSETFLAG_DEFAULT = (0),
        PROPSETFLAG_NONSIMPLE = (1),
        PROPSETFLAG_ANSI = (2),
        PID_DICTIONARY = (0),
        PID_CODEPAGE = (0x1),
        PID_FIRST_USABLE = (0x2),
        PID_FIRST_NAME_DEFAULT = (0xfff),
        PID_LOCALE = (0x80000000),
        PID_MODIFY_TIME = (0x80000001),
        PID_SECURITY = (0x80000002),
        PID_ILLEGAL = (0xffffffff),
        PIDSI_TITLE = 0x00000002,
        PIDSI_SUBJECT = 0x00000003,
        PIDSI_AUTHOR = 0x00000004,
        PIDSI_KEYWORDS = 0x00000005,
        PIDSI_COMMENTS = 0x00000006,
        PIDSI_TEMPLATE = 0x00000007,
        PIDSI_LASTAUTHOR = 0x00000008,
        PIDSI_REVNUMBER = 0x00000009,
        PIDSI_EDITTIME = 0x0000000a,
        PIDSI_LASTPRINTED = 0x0000000b,
        PIDSI_CREATE_DTM = 0x0000000c,
        PIDSI_LASTSAVE_DTM = 0x0000000d,
        PIDSI_PAGECOUNT = 0x0000000e,
        PIDSI_WORDCOUNT = 0x0000000f,
        PIDSI_CHARCOUNT = 0x00000010,
        PIDSI_THUMBNAIL = 0x00000011,
        PIDSI_APPNAME = 0x00000012,
        PIDSI_DOC_SECURITY = 0x00000013,
        PRSPEC_INVALID = (0xffffffff),
        PRSPEC_LPWSTR = (0),
        PRSPEC_PROPID = (1),
        PROPSETHDR_OSVERSION_UNKNOWN = 0xFFFFFFFF,
        PSP_DEFAULT = 0x0000,
        PSP_DLGINDIRECT = 0x0001,
        PSP_USEHICON = 0x0002,
        PSP_USEICONID = 0x0004,
        PSP_USETITLE = 0x0008,
        PSP_RTLREADING = 0x0010,
        PSP_HASHELP = 0x0020,
        PSP_USEREFPARENT = 0x0040,
        PSP_USECALLBACK = 0x0080,
        PSPCB_RELEASE = 1,
        PSPCB_CREATE = 2,
        PSH_DEFAULT = 0x0000,
        PSH_PROPTITLE = 0x0001,
        PSH_USEHICON = 0x0002,
        PSH_USEICONID = 0x0004,
        PSH_PROPSHEETPAGE = 0x0008,
        PSH_WIZARD = 0x0020,
        PSH_USEPSTARTPAGE = 0x0040,
        PSH_NOAPPLYNOW = 0x0080,
        PSH_USECALLBACK = 0x0100,
        PSH_HASHELP = 0x0200,
        PSH_MODELESS = 0x0400,
        PSH_RTLREADING = 0x0800,
        PSCB_INITIALIZED = 1,
        PSCB_PRECREATE = 2,
        PSN_FIRST = (0-200),
        PSN_LAST = (0-299),
        PSN_SETACTIVE = ((0-200)-0),
        PSN_KILLACTIVE = ((0-200)-1),
        PSN_APPLY = ((0-200)-2),
        PSN_RESET = ((0-200)-3),
        PSN_HELP = ((0-200)-5),
        PSN_WIZBACK = ((0-200)-6),
        PSN_WIZNEXT = ((0-200)-7),
        PSN_WIZFINISH = ((0-200)-8),
        PSN_QUERYCANCEL = ((0-200)-9),
        PSNRET_NOERROR = 0,
        PSNRET_INVALID = 1,
        PSNRET_INVALID_NOCHANGEPAGE = 2,
        PSWIZB_BACK = 0x00000001,
        PSWIZB_NEXT = 0x00000002,
        PSWIZB_FINISH = 0x00000004,
        PSWIZB_DISABLEDFINISH = 0x00000008,
        PSBTN_BACK = 0,
        PSBTN_NEXT = 1,
        PSBTN_FINISH = 2,
        PSBTN_OK = 3,
        PSBTN_APPLYNOW = 4,
        PSBTN_CANCEL = 5,
        PSBTN_HELP = 6,
        PSBTN_MAX = 6,
        PROP_SM_CXDLG = 212,
        PROP_SM_CYDLG = 188,
        PROP_MED_CXDLG = 227,
        PROP_MED_CYDLG = 215,
        PROP_LG_CXDLG = 252,
        PROP_LG_CYDLG = 218,
        PO_DELETE = 0x0013,
        PO_RENAME = 0x0014,
        PO_PORTCHANGE = 0x0020,
        PO_REN_PORT = 0x0034,
        PROGRESS_CONTINUE = 0,
        PROGRESS_CANCEL = 1,
        PROGRESS_STOP = 2,
        PROGRESS_QUIET = 3,
        PIPE_ACCESS_INBOUND = 0x00000001,
        PIPE_ACCESS_OUTBOUND = 0x00000002,
        PIPE_ACCESS_DUPLEX = 0x00000003,
        PIPE_CLIENT_END = 0x00000000,
        PIPE_SERVER_END = 0x00000001,
        PIPE_WAIT = 0x00000000,
        PIPE_NOWAIT = 0x00000001,
        PIPE_READMODE_BYTE = 0x00000000,
        PIPE_READMODE_MESSAGE = 0x00000002,
        PIPE_TYPE_BYTE = 0x00000000,
        PIPE_TYPE_MESSAGE = 0x00000004,
        PIPE_UNLIMITED_INSTANCES = 255,
        PST_UNSPECIFIED = (0x00000000),
        PST_RS232 = (0x00000001),
        PST_PARALLELPORT = (0x00000002),
        PST_RS422 = (0x00000003),
        PST_RS423 = (0x00000004),
        PST_RS449 = (0x00000005),
        PST_MODEM = (0x00000006),
        PST_FAX = (0x00000021),
        PST_SCANNER = (0x00000022),
        PST_NETWORK_BRIDGE = (0x00000100),
        PST_LAT = (0x00000101),
        PST_TCPIP_TELNET = (0x00000102),
        PST_X25 = (0x00000103),
        PCF_DTRDSR = (0x0001),
        PCF_RTSCTS = (0x0002),
        PCF_RLSD = (0x0004),
        PCF_PARITY_CHECK = (0x0008),
        PCF_XONXOFF = (0x0010),
        PCF_SETXCHAR = (0x0020),
        PCF_TOTALTIMEOUTS = (0x0040),
        PCF_INTTIMEOUTS = (0x0080),
        PCF_SPECIALCHARS = (0x0100),
        PCF_16BITMODE = (0x0200),
        PARITY_NONE = (0x0100),
        PARITY_ODD = (0x0200),
        PARITY_EVEN = (0x0400),
        PARITY_MARK = (0x0800),
        PARITY_SPACE = (0x1000),
        PROFILE_USER = 0x10000000,
        PROFILE_KERNEL = 0x20000000,
        PROFILE_SERVER = 0x40000000,
        PURGE_TXABORT = 0x0001,
        PURGE_RXABORT = 0x0002,
        PURGE_TXCLEAR = 0x0004,
        PURGE_RXCLEAR = 0x0008,
        PROCESS_HEAP_REGION = 0x0001,
        PROCESS_HEAP_UNCOMMITTED_RANGE = 0x0002,
        PROCESS_HEAP_ENTRY_BUSY = 0x0004,
        PROCESS_HEAP_ENTRY_MOVEABLE = 0x0010,
        PROCESS_HEAP_ENTRY_DDESHARE = 0x0020,
        PUBLICKEYBLOB = 0x6,
        PRIVATEKEYBLOB = 0x7,
        PKCS5_PADDING = 1,
        PP_ENUMALGS = 1,
        PP_ENUMCONTAINERS = 2,
        PP_IMPTYPE = 3,
        PP_NAME = 4,
        PP_VERSION = 5,
        PP_CONTAINER = 6,
        PP_CLIENT_HWND = 1,
        PROV_RSA_FULL = 1,
        PROV_RSA_SIG = 2,
        PROV_DSS = 3,
        PROV_FORTEZZA = 4,
        PROV_MS_EXCHANGE = 5,
        PROV_SSL = 6,
        PROV_STT_MER = 7,
        PROV_STT_ACQ = 8,
        PROV_STT_BRND = 9,
        PROV_STT_ROOT = 10,
        PROV_STT_ISS = 11,
        PERSIST_E_SIZEDEFINITE = 0x800B0009,
        PERSIST_E_SIZEINDEFINITE = 0x800B000A,
        PERSIST_E_NOTSELFSIZING = 0x800B000B,
        POLYFILL_LAST = 2,
        PASSTHROUGH = 19,
        POSTSCRIPT_DATA = 37,
        POSTSCRIPT_IGNORE = 38,
        POSTSCRIPT_PASSTHROUGH = 4115,
        PR_JOBSTATUS = 0x0000,
        PROOF_QUALITY = 2,
        PANOSE_COUNT = 10,
        PAN_FAMILYTYPE_INDEX = 0,
        PAN_SERIFSTYLE_INDEX = 1,
        PAN_WEIGHT_INDEX = 2,
        PAN_PROPORTION_INDEX = 3,
        PAN_CONTRAST_INDEX = 4,
        PAN_STROKEVARIATION_INDEX = 5,
        PAN_ARMSTYLE_INDEX = 6,
        PAN_LETTERFORM_INDEX = 7,
        PAN_MIDLINE_INDEX = 8,
        PAN_XHEIGHT_INDEX = 9,
        PAN_CULTURE_LATIN = 0,
        PAN_ANY = 0,
        PAN_NO_FIT = 1,
        PAN_FAMILY_TEXT_DISPLAY = 2,
        PAN_FAMILY_SCRIPT = 3,
        PAN_FAMILY_DECORATIVE = 4,
        PAN_FAMILY_PICTORIAL = 5,
        PAN_SERIF_COVE = 2,
        PAN_SERIF_OBTUSE_COVE = 3,
        PAN_SERIF_SQUARE_COVE = 4,
        PAN_SERIF_OBTUSE_SQUARE_COVE = 5,
        PAN_SERIF_SQUARE = 6,
        PAN_SERIF_THIN = 7,
        PAN_SERIF_BONE = 8,
        PAN_SERIF_EXAGGERATED = 9,
        PAN_SERIF_TRIANGLE = 10,
        PAN_SERIF_NORMAL_SANS = 11,
        PAN_SERIF_OBTUSE_SANS = 12,
        PAN_SERIF_PERP_SANS = 13,
        PAN_SERIF_FLARED = 14,
        PAN_SERIF_ROUNDED = 15,
        PAN_WEIGHT_VERY_LIGHT = 2,
        PAN_WEIGHT_LIGHT = 3,
        PAN_WEIGHT_THIN = 4,
        PAN_WEIGHT_BOOK = 5,
        PAN_WEIGHT_MEDIUM = 6,
        PAN_WEIGHT_DEMI = 7,
        PAN_WEIGHT_BOLD = 8,
        PAN_WEIGHT_HEAVY = 9,
        PAN_WEIGHT_BLACK = 10,
        PAN_WEIGHT_NORD = 11,
        PAN_PROP_OLD_STYLE = 2,
        PAN_PROP_MODERN = 3,
        PAN_PROP_EVEN_WIDTH = 4,
        PAN_PROP_EXPANDED = 5,
        PAN_PROP_CONDENSED = 6,
        PAN_PROP_VERY_EXPANDED = 7,
        PAN_PROP_VERY_CONDENSED = 8,
        PAN_PROP_MONOSPACED = 9,
        PAN_CONTRAST_NONE = 2,
        PAN_CONTRAST_VERY_LOW = 3,
        PAN_CONTRAST_LOW = 4,
        PAN_CONTRAST_MEDIUM_LOW = 5,
        PAN_CONTRAST_MEDIUM = 6,
        PAN_CONTRAST_MEDIUM_HIGH = 7,
        PAN_CONTRAST_HIGH = 8,
        PAN_CONTRAST_VERY_HIGH = 9,
        PAN_STROKE_GRADUAL_DIAG = 2,
        PAN_STROKE_GRADUAL_TRAN = 3,
        PAN_STROKE_GRADUAL_VERT = 4,
        PAN_STROKE_GRADUAL_HORZ = 5,
        PAN_STROKE_RAPID_VERT = 6,
        PAN_STROKE_RAPID_HORZ = 7,
        PAN_STROKE_INSTANT_VERT = 8,
        PAN_STRAIGHT_ARMS_HORZ = 2,
        PAN_STRAIGHT_ARMS_WEDGE = 3,
        PAN_STRAIGHT_ARMS_VERT = 4,
        PAN_STRAIGHT_ARMS_SINGLE_SERIF = 5,
        PAN_STRAIGHT_ARMS_DOUBLE_SERIF = 6,
        PAN_BENT_ARMS_HORZ = 7,
        PAN_BENT_ARMS_WEDGE = 8,
        PAN_BENT_ARMS_VERT = 9,
        PAN_BENT_ARMS_SINGLE_SERIF = 10,
        PAN_BENT_ARMS_DOUBLE_SERIF = 11,
        PAN_LETT_NORMAL_CONTACT = 2,
        PAN_LETT_NORMAL_WEIGHTED = 3,
        PAN_LETT_NORMAL_BOXED = 4,
        PAN_LETT_NORMAL_FLATTENED = 5,
        PAN_LETT_NORMAL_ROUNDED = 6,
        PAN_LETT_NORMAL_OFF_CENTER = 7,
        PAN_LETT_NORMAL_SQUARE = 8,
        PAN_LETT_OBLIQUE_CONTACT = 9,
        PAN_LETT_OBLIQUE_WEIGHTED = 10,
        PAN_LETT_OBLIQUE_BOXED = 11,
        PAN_LETT_OBLIQUE_FLATTENED = 12,
        PAN_LETT_OBLIQUE_ROUNDED = 13,
        PAN_LETT_OBLIQUE_OFF_CENTER = 14,
        PAN_LETT_OBLIQUE_SQUARE = 15,
        PAN_MIDLINE_STANDARD_TRIMMED = 2,
        PAN_MIDLINE_STANDARD_POINTED = 3,
        PAN_MIDLINE_STANDARD_SERIFED = 4,
        PAN_MIDLINE_HIGH_TRIMMED = 5,
        PAN_MIDLINE_HIGH_POINTED = 6,
        PAN_MIDLINE_HIGH_SERIFED = 7,
        PAN_MIDLINE_LOW_TRIMMED = 11,
        PAN_MIDLINE_LOW_POINTED = 12,
        PAN_MIDLINE_LOW_SERIFED = 13,
        PAN_XHEIGHT_DUCKING_SMALL = 5,
        PAN_XHEIGHT_DUCKING_STD = 6,
        PAN_XHEIGHT_DUCKING_LARGE = 7,
        PC_RESERVED = 0x01,
        PC_EXPLICIT = 0x02,
        PC_NOCOLLAPSE = 0x04,
        PT_CLOSEFIGURE = 0x01,
        PT_LINETO = 0x02,
        PT_BEZIERTO = 0x04,
        PT_MOVETO = 0x06,
        PS_SOLID = 0,
        PS_DASH = 1,
        PS_DOT = 2,
        PS_DASHDOT = 3,
        PS_DASHDOTDOT = 4,
        PS_NULL = 5,
        PS_INSIDEFRAME = 6,
        PS_USERSTYLE = 7,
        PS_ALTERNATE = 8,
        PS_STYLE_MASK = 0x0000000F,
        PS_ENDCAP_ROUND = 0x00000000,
        PS_ENDCAP_SQUARE = 0x00000100,
        PS_ENDCAP_FLAT = 0x00000200,
        PS_ENDCAP_MASK = 0x00000F00,
        PS_JOIN_ROUND = 0x00000000,
        PS_JOIN_BEVEL = 0x00001000,
        PS_JOIN_MITER = 0x00002000,
        PS_JOIN_MASK = 0x0000F000,
        PS_COSMETIC = 0x00000000,
        PS_GEOMETRIC = 0x00010000,
        PS_TYPE_MASK = 0x000F0000,
        PLANES = 14,
        PDEVICESIZE = 26,
        POLYGONALCAPS = 32,
        PHYSICALWIDTH = 110,
        PHYSICALHEIGHT = 111,
        PHYSICALOFFSETX = 112,
        PHYSICALOFFSETY = 113,
        PC_NONE = 0,
        PC_POLYGON = 1,
        PC_RECTANGLE = 2,
        PC_WINDPOLYGON = 4,
        PC_TRAPEZOID = 4,
        PC_SCANLINE = 8,
        PC_WIDE = 16,
        PC_STYLED = 32,
        PC_WIDESTYLED = 64,
        PC_INTERIORS = 128,
        PC_POLYPOLYGON = 256,
        PC_PATHS = 512,
        PFD_TYPE_RGBA = 0,
        PFD_TYPE_COLORINDEX = 1,
        PFD_MAIN_PLANE = 0,
        PFD_OVERLAY_PLANE = 1,
        PFD_UNDERLAY_PLANE = (-1),
        PFD_DOUBLEBUFFER = 0x00000001,
        PFD_STEREO = 0x00000002,
        PFD_DRAW_TO_WINDOW = 0x00000004,
        PFD_DRAW_TO_BITMAP = 0x00000008,
        PFD_SUPPORT_GDI = 0x00000010,
        PFD_SUPPORT_OPENGL = 0x00000020,
        PFD_GENERIC_FORMAT = 0x00000040,
        PFD_NEED_PALETTE = 0x00000080,
        PFD_NEED_SYSTEM_PALETTE = 0x00000100,
        PFD_SWAP_EXCHANGE = 0x00000200,
        PFD_SWAP_COPY = 0x00000400,
        PFD_SWAP_LAYER_BUFFERS = 0x00000800,
        PFD_GENERIC_ACCELERATED = 0x00001000,
        PFD_DEPTH_DONTCARE = 0x20000000,
        PFD_DOUBLEBUFFER_DONTCARE = 0x40000000,
        PFD_STEREO_DONTCARE = 0x80000000,
        PP_DISPLAYERRORS = 0x01,
        PROCESS_TERMINATE = (0x0001),
        PROCESS_CREATE_THREAD = (0x0002),
        PROCESS_VM_OPERATION = (0x0008),
        PROCESS_VM_READ = (0x0010),
        PROCESS_VM_WRITE = (0x0020),
        PROCESS_DUP_HANDLE = (0x0040),
        PROCESS_CREATE_PROCESS = (0x0080),
        PROCESS_SET_QUOTA = (0x0100),
        PROCESS_SET_INFORMATION = (0x0200),
        PROCESS_QUERY_INFORMATION = (0x0400),
        PROCESSOR_INTEL_386 = 386,
        PROCESSOR_INTEL_486 = 486,
        PROCESSOR_INTEL_PENTIUM = 586,
        PROCESSOR_MIPS_R4000 = 4000,
        PROCESSOR_ALPHA_21064 = 21064,
        PROCESSOR_ARCHITECTURE_INTEL = 0,
        PROCESSOR_ARCHITECTURE_MIPS = 1,
        PROCESSOR_ARCHITECTURE_ALPHA = 2,
        PROCESSOR_ARCHITECTURE_PPC = 3,
        PROCESSOR_ARCHITECTURE_UNKNOWN = 0xFFFF,
        PF_FLOATING_POINT_PRECISION_ERRATA = 0,
        PF_FLOATING_POINT_EMULATED = 1,
        PF_COMPARE_EXCHANGE_DOUBLE = 2,
        PF_MMX_INSTRUCTIONS_AVAILABLE = 3,
        PAGE_NOACCESS = 0x01,
        PAGE_READONLY = 0x02,
        PAGE_READWRITE = 0x04,
        PAGE_WRITECOPY = 0x08,
        PAGE_EXECUTE = 0x10,
        PAGE_EXECUTE_READ = 0x20,
        PAGE_EXECUTE_READWRITE = 0x40,
        PAGE_EXECUTE_WRITECOPY = 0x80,
        PAGE_GUARD = 0x100,
        PAGE_NOCACHE = 0x200,
        PRIVILEGE_SET_ALL_NECESSARY = (1),
        PERF_DATA_VERSION = 1,
        PERF_DATA_REVISION = 1,
        PERF_NO_INSTANCES = -1,
        PERF_SIZE_DWORD = 0x00000000,
        PERF_SIZE_LARGE = 0x00000100,
        PERF_SIZE_ZERO = 0x00000200,
        PERF_SIZE_VARIABLE_LEN = 0x00000300,
        PERF_TYPE_NUMBER = 0x00000000,
        PERF_TYPE_COUNTER = 0x00000400,
        PERF_TYPE_TEXT = 0x00000800,
        PERF_TYPE_ZERO = 0x00000C00,
        PERF_NUMBER_HEX = 0x00000000,
        PERF_NUMBER_DECIMAL = 0x00010000,
        PERF_NUMBER_DEC_1000 = 0x00020000,
        PERF_COUNTER_VALUE = 0x00000000,
        PERF_COUNTER_RATE = 0x00010000,
        PERF_COUNTER_FRACTION = 0x00020000,
        PERF_COUNTER_BASE = 0x00030000,
        PERF_COUNTER_ELAPSED = 0x00040000,
        PERF_COUNTER_QUEUELEN = 0x00050000,
        PERF_COUNTER_HISTOGRAM = 0x00060000,
        PERF_TEXT_UNICODE = 0x00000000,
        PERF_TEXT_ASCII = 0x00010000,
        PERF_TIMER_TICK = 0x00000000,
        PERF_TIMER_100NS = 0x00100000,
        PERF_OBJECT_TIMER = 0x00200000,
        PERF_DELTA_COUNTER = 0x00400000,
        PERF_DELTA_BASE = 0x00800000,
        PERF_INVERSE_COUNTER = 0x01000000,
        PERF_MULTI_COUNTER = 0x02000000,
        PERF_DISPLAY_NO_SUFFIX = 0x00000000,
        PERF_DISPLAY_PER_SEC = 0x10000000,
        PERF_DISPLAY_PERCENT = 0x20000000,
        PERF_DISPLAY_SECONDS = 0x30000000,
        PERF_DISPLAY_NOSHOW = 0x40000000,
        PERF_COUNTER_HISTOGRAM_TYPE = 0x80000000,
        PERF_DETAIL_NOVICE = 100,
        PERF_DETAIL_ADVANCED = 200,
        PERF_DETAIL_EXPERT = 300,
        PERF_DETAIL_WIZARD = 400,
        PERF_NO_UNIQUE_ID = -1,
        PROVIDER_KEEPS_VALUE_LENGTH = 0x1,
        PRINTER_CONTROL_PAUSE = 1,
        PRINTER_CONTROL_RESUME = 2,
        PRINTER_CONTROL_PURGE = 3,
        PRINTER_CONTROL_SET_STATUS = 4,
        PRINTER_STATUS_PAUSED = 0x00000001,
        PRINTER_STATUS_ERROR = 0x00000002,
        PRINTER_STATUS_PENDING_DELETION = 0x00000004,
        PRINTER_STATUS_PAPER_JAM = 0x00000008,
        PRINTER_STATUS_PAPER_OUT = 0x00000010,
        PRINTER_STATUS_MANUAL_FEED = 0x00000020,
        PRINTER_STATUS_PAPER_PROBLEM = 0x00000040,
        PRINTER_STATUS_OFFLINE = 0x00000080,
        PRINTER_STATUS_IO_ACTIVE = 0x00000100,
        PRINTER_STATUS_BUSY = 0x00000200,
        PRINTER_STATUS_PRINTING = 0x00000400,
        PRINTER_STATUS_OUTPUT_BIN_FULL = 0x00000800,
        PRINTER_STATUS_NOT_AVAILABLE = 0x00001000,
        PRINTER_STATUS_WAITING = 0x00002000,
        PRINTER_STATUS_PROCESSING = 0x00004000,
        PRINTER_STATUS_INITIALIZING = 0x00008000,
        PRINTER_STATUS_WARMING_UP = 0x00010000,
        PRINTER_STATUS_TONER_LOW = 0x00020000,
        PRINTER_STATUS_NO_TONER = 0x00040000,
        PRINTER_STATUS_PAGE_PUNT = 0x00080000,
        PRINTER_STATUS_USER_INTERVENTION = 0x00100000,
        PRINTER_STATUS_OUT_OF_MEMORY = 0x00200000,
        PRINTER_STATUS_DOOR_OPEN = 0x00400000,
        PRINTER_STATUS_SERVER_UNKNOWN = 0x00800000,
        PRINTER_STATUS_POWER_SAVE = 0x01000000,
        PRINTER_ATTRIBUTE_QUEUED = 0x00000001,
        PRINTER_ATTRIBUTE_DIRECT = 0x00000002,
        PRINTER_ATTRIBUTE_DEFAULT = 0x00000004,
        PRINTER_ATTRIBUTE_SHARED = 0x00000008,
        PRINTER_ATTRIBUTE_NETWORK = 0x00000010,
        PRINTER_ATTRIBUTE_HIDDEN = 0x00000020,
        PRINTER_ATTRIBUTE_LOCAL = 0x00000040,
        PRINTER_ATTRIBUTE_ENABLE_DEVQ = 0x00000080,
        PRINTER_ATTRIBUTE_KEEPPRINTEDJOBS = 0x00000100,
        PRINTER_ATTRIBUTE_DO_COMPLETE_FIRST = 0x00000200,
        PRINTER_ATTRIBUTE_WORK_OFFLINE = 0x00000400,
        PRINTER_ATTRIBUTE_ENABLE_BIDI = 0x00000800,
        PRINTER_ATTRIBUTE_RAW_ONLY = 0x00001000,
        PORT_TYPE_WRITE = 0x0001,
        PORT_TYPE_READ = 0x0002,
        PORT_TYPE_REDIRECTED = 0x0004,
        PORT_TYPE_NET_ATTACHED = 0x0008,
        PORT_STATUS_TYPE_ERROR = 1,
        PORT_STATUS_TYPE_WARNING = 2,
        PORT_STATUS_TYPE_INFO = 3,
        PORT_STATUS_OFFLINE = 1,
        PORT_STATUS_PAPER_JAM = 2,
        PORT_STATUS_PAPER_OUT = 3,
        PORT_STATUS_OUTPUT_BIN_FULL = 4,
        PORT_STATUS_PAPER_PROBLEM = 5,
        PORT_STATUS_NO_TONER = 6,
        PORT_STATUS_DOOR_OPEN = 7,
        PORT_STATUS_USER_INTERVENTION = 8,
        PORT_STATUS_OUT_OF_MEMORY = 9,
        PORT_STATUS_TONER_LOW = 10,
        PORT_STATUS_WARMING_UP = 11,
        PORT_STATUS_POWER_SAVE = 12,
        PRINTER_ENUM_DEFAULT = 0x00000001,
        PRINTER_ENUM_LOCAL = 0x00000002,
        PRINTER_ENUM_CONNECTIONS = 0x00000004,
        PRINTER_ENUM_FAVORITE = 0x00000004,
        PRINTER_ENUM_NAME = 0x00000008,
        PRINTER_ENUM_REMOTE = 0x00000010,
        PRINTER_ENUM_SHARED = 0x00000020,
        PRINTER_ENUM_NETWORK = 0x00000040,
        PRINTER_ENUM_EXPAND = 0x00004000,
        PRINTER_ENUM_CONTAINER = 0x00008000,
        PRINTER_ENUM_ICONMASK = 0x00ff0000,
        PRINTER_ENUM_ICON1 = 0x00010000,
        PRINTER_ENUM_ICON2 = 0x00020000,
        PRINTER_ENUM_ICON3 = 0x00040000,
        PRINTER_ENUM_ICON4 = 0x00080000,
        PRINTER_ENUM_ICON5 = 0x00100000,
        PRINTER_ENUM_ICON6 = 0x00200000,
        PRINTER_ENUM_ICON7 = 0x00400000,
        PRINTER_ENUM_ICON8 = 0x00800000,
        PRINTER_NOTIFY_TYPE = 0x00,
        PRINTER_NOTIFY_FIELD_SERVER_NAME = 0x00,
        PRINTER_NOTIFY_FIELD_PRINTER_NAME = 0x01,
        PRINTER_NOTIFY_FIELD_SHARE_NAME = 0x02,
        PRINTER_NOTIFY_FIELD_PORT_NAME = 0x03,
        PRINTER_NOTIFY_FIELD_DRIVER_NAME = 0x04,
        PRINTER_NOTIFY_FIELD_COMMENT = 0x05,
        PRINTER_NOTIFY_FIELD_LOCATION = 0x06,
        PRINTER_NOTIFY_FIELD_DEVMODE = 0x07,
        PRINTER_NOTIFY_FIELD_SEPFILE = 0x08,
        PRINTER_NOTIFY_FIELD_PRINT_PROCESSOR = 0x09,
        PRINTER_NOTIFY_FIELD_PARAMETERS = 0x0A,
        PRINTER_NOTIFY_FIELD_DATATYPE = 0x0B,
        PRINTER_NOTIFY_FIELD_SECURITY_DESCRIPTOR = 0x0C,
        PRINTER_NOTIFY_FIELD_ATTRIBUTES = 0x0D,
        PRINTER_NOTIFY_FIELD_PRIORITY = 0x0E,
        PRINTER_NOTIFY_FIELD_DEFAULT_PRIORITY = 0x0F,
        PRINTER_NOTIFY_FIELD_START_TIME = 0x10,
        PRINTER_NOTIFY_FIELD_UNTIL_TIME = 0x11,
        PRINTER_NOTIFY_FIELD_STATUS = 0x12,
        PRINTER_NOTIFY_FIELD_STATUS_STRING = 0x13,
        PRINTER_NOTIFY_FIELD_CJOBS = 0x14,
        PRINTER_NOTIFY_FIELD_AVERAGE_PPM = 0x15,
        PRINTER_NOTIFY_FIELD_TOTAL_PAGES = 0x16,
        PRINTER_NOTIFY_FIELD_PAGES_PRINTED = 0x17,
        PRINTER_NOTIFY_FIELD_TOTAL_BYTES = 0x18,
        PRINTER_NOTIFY_FIELD_BYTES_PRINTED = 0x19,
        PRINTER_NOTIFY_OPTIONS_REFRESH = 0x01,
        PRINTER_NOTIFY_INFO_DISCARDED = 0x01,
        PRINTER_CHANGE_ADD_PRINTER = 0x00000001,
        PRINTER_CHANGE_SET_PRINTER = 0x00000002,
        PRINTER_CHANGE_DELETE_PRINTER = 0x00000004,
        PRINTER_CHANGE_FAILED_CONNECTION_PRINTER = 0x00000008,
        PRINTER_CHANGE_PRINTER = 0x000000FF,
        PRINTER_CHANGE_ADD_JOB = 0x00000100,
        PRINTER_CHANGE_SET_JOB = 0x00000200,
        PRINTER_CHANGE_DELETE_JOB = 0x00000400,
        PRINTER_CHANGE_WRITE_JOB = 0x00000800,
        PRINTER_CHANGE_JOB = 0x0000FF00,
        PRINTER_CHANGE_ADD_FORM = 0x00010000,
        PRINTER_CHANGE_SET_FORM = 0x00020000,
        PRINTER_CHANGE_DELETE_FORM = 0x00040000,
        PRINTER_CHANGE_FORM = 0x00070000,
        PRINTER_CHANGE_ADD_PORT = 0x00100000,
        PRINTER_CHANGE_CONFIGURE_PORT = 0x00200000,
        PRINTER_CHANGE_DELETE_PORT = 0x00400000,
        PRINTER_CHANGE_PORT = 0x00700000,
        PRINTER_CHANGE_ADD_PRINT_PROCESSOR = 0x01000000,
        PRINTER_CHANGE_DELETE_PRINT_PROCESSOR = 0x04000000,
        PRINTER_CHANGE_PRINT_PROCESSOR = 0x07000000,
        PRINTER_CHANGE_ADD_PRINTER_DRIVER = 0x10000000,
        PRINTER_CHANGE_SET_PRINTER_DRIVER = 0x20000000,
        PRINTER_CHANGE_DELETE_PRINTER_DRIVER = 0x40000000,
        PRINTER_CHANGE_PRINTER_DRIVER = 0x70000000,
        PRINTER_CHANGE_TIMEOUT = 0x80000000,
        PRINTER_CHANGE_ALL = 0x7777FFFF,
        PRINTER_ERROR_INFORMATION = 0x80000000,
        PRINTER_ERROR_WARNING = 0x40000000,
        PRINTER_ERROR_SEVERE = 0x20000000,
        PRINTER_ERROR_OUTOFPAPER = 0x00000001,
        PRINTER_ERROR_JAM = 0x00000002,
        PRINTER_ERROR_OUTOFTONER = 0x00000004,
        PRINTER_ACCESS_ADMINISTER = 0x00000004,
        PRINTER_ACCESS_USE = 0x00000008,
        PWR_OK = 1,
        PWR_FAIL = (-1),
        PWR_SUSPENDREQUEST = 1,
        PWR_SUSPENDRESUME = 2,
        PWR_CRITICALRESUME = 3,
        PRF_CHECKVISIBLE = 0x00000001,
        PRF_NONCLIENT = 0x00000002,
        PRF_CLIENT = 0x00000004,
        PRF_ERASEBKGND = 0x00000008,
        PRF_CHILDREN = 0x00000010,
        PRF_OWNED = 0x00000020,
        PM_NOREMOVE = 0x0000,
        PM_REMOVE = 0x0001,
        PM_NOYIELD = 0x0002,
        PSM_PAGEINFO = (0x0400+100),
        PSM_SHEETINFO = (0x0400+101),
        PSI_SETACTIVE = 0x0001,
        PSI_KILLACTIVE = 0x0002,
        PSI_APPLY = 0x0003,
        PSI_RESET = 0x0004,
        PSI_HASHELP = 0x0005,
        PSI_HELP = 0x0006,
        PSI_CHANGED = 0x0001,
        PSI_GUISTART = 0x0002,
        PSI_REBOOT = 0x0003,
        PSI_GETSIBLINGS = 0x0004,
        PBS_SMOOTH = 0x01,
        PBS_VERTICAL = 0x04,
        PBM_SETRANGE = (0x0400+1),
        PBM_SETPOS = (0x0400+2),
        PBM_DELTAPOS = (0x0400+3),
        PBM_SETSTEP = (0x0400+4),
        PBM_STEPIT = (0x0400+5),
        PBM_SETRANGE32 = (0x0400+6),
        PBM_GETRANGE = (0x0400+7),
        PBM_GETPOS = (0x0400+8),
        PSM_SETCURSEL = (0x0400+101),
        PSM_REMOVEPAGE = (0x0400+102),
        PSM_ADDPAGE = (0x0400+103),
        PSM_CHANGED = (0x0400+104),
        PSM_RESTARTWINDOWS = (0x0400+105),
        PSM_REBOOTSYSTEM = (0x0400+106),
        PSM_CANCELTOCLOSE = (0x0400+107),
        PSM_QUERYSIBLINGS = (0x0400+108),
        PSM_UNCHANGED = (0x0400+109),
        PSM_APPLY = (0x0400+110),
        PSM_SETTITLEA = (0x0400+111),
        PSM_SETTITLEW = (0x0400+120),
        PSM_SETWIZBUTTONS = (0x0400+112),
        PSM_PRESSBUTTON = (0x0400+113),
        PSM_SETCURSELID = (0x0400+114),
        PSM_SETFINISHTEXTA = (0x0400+115),
        PSM_SETFINISHTEXTW = (0x0400+121),
        PSM_GETTABCONTROL = (0x0400+116),
        PSM_ISDIALOGMESSAGE = (0x0400+117),
        PSM_GETCURRENTPAGEHWND = (0x0400+118),
        PATCOPY = 0x00F00021,
        PATPAINT = 0x00FB0A09,
        PATINVERT = 0x005A0049,
        PGN_FIRST = (0-900),
        PGN_LAST = (0-950);
    
    /* RichEdit: Far East specific flags */
    int PC_FOLLOWING            = 1,
        PC_LEADING              = 2,
        PC_OVERFLOW             = 3,
        PC_DELIMITER            = 4;        

    /* RichEdit: PARAFORMAT mask values */
    int PFM_STARTINDENT         = 0x00000001,
        PFM_RIGHTINDENT         = 0x00000002,
        PFM_OFFSET              = 0x00000004,
        PFM_ALIGNMENT           = 0x00000008,
        PFM_TABSTOPS            = 0x00000010,
        PFM_NUMBERING           = 0x00000020,
        PFM_OFFSETINDENT        = 0x80000000;

    /* RichEdit: PARAFORMAT numbering options */
    short PFN_BULLET            = 0x0001;

    /* RichEdit: PARAFORMAT alignment options */
    short PFA_LEFT              = 0x0001,
          PFA_RIGHT             = 0x0002,
          PFA_CENTER            = 0x0003,
          PFA_JUSTIFY           = 0x0004;   /* New paragraph-alignment option 2.0 (*)

    /* RichEdit: PARAFORMAT "ALL" mask */
    int PFM_ALL                 = (PFM_STARTINDENT | PFM_RIGHTINDENT |
                                    PFM_OFFSET | PFM_ALIGNMENT |
                                    PFM_TABSTOPS | PFM_NUMBERING |
                                    PFM_OFFSETINDENT);

    /* RichEdit: PARAFORMAT 2.0 masks and effects */
    int PFM_SPACEBEFORE         = 0x00000040,
        PFM_SPACEAFTER          = 0x00000080,
        PFM_LINESPACING         = 0x00000100,
        PFM_STYLE               = 0x00000400,
        PFM_BORDER              = 0x00000800,       /* (*)  */
        PFM_SHADING             = 0x00001000,       /* (*)  */
        PFM_NUMBERINGSTYLE      = 0x00002000,       /* (*)  */
        PFM_NUMBERINGTAB        = 0x00004000,       /* (*)  */
        PFM_NUMBERINGSTART      = 0x00008000,       /* (*)  */
        PFM_RTLPARA             = 0x00010000,
        PFM_KEEP                = 0x00020000,       /* (*)  */
        PFM_KEEPNEXT            = 0x00040000,       /* (*)  */
        PFM_PAGEBREAKBEFORE     = 0x00080000,       /* (*)  */
        PFM_NOLINENUMBER        = 0x00100000,       /* (*)  */
        PFM_NOWIDOWCONTROL      = 0x00200000,       /* (*)  */
        PFM_DONOTHYPHEN         = 0x00400000,       /* (*)  */
        PFM_SIDEBYSIDE          = 0x00800000,       /* (*)  */
        PFM_TABLE               = 0xc0000000,       /* (*)  */

        /* Note: PARAFORMAT has no effects */
        PFM_EFFECTS             = (PFM_RTLPARA | PFM_KEEP |
                                    PFM_KEEPNEXT | PFM_TABLE |
                                    PFM_PAGEBREAKBEFORE | PFM_NOLINENUMBER |
                                    PFM_NOWIDOWCONTROL | PFM_DONOTHYPHEN |
                                    PFM_SIDEBYSIDE | PFM_TABLE),
        PFM_ALL2                = (PFM_ALL | PFM_EFFECTS |
                                    PFM_SPACEBEFORE | PFM_SPACEAFTER |
                                    PFM_LINESPACING | PFM_STYLE |
                                    PFM_SHADING | PFM_BORDER |
                                    PFM_NUMBERINGTAB | PFM_NUMBERINGSTART |
                                    PFM_NUMBERINGSTYLE),
                                    
        PFE_RTLPARA             = (PFM_RTLPARA          >> 16),
        PFE_KEEP                = (PFM_KEEP             >> 16),     /* (*)  */
        PFE_KEEPNEXT            = (PFM_KEEPNEXT         >> 16),     /* (*)  */
        PFE_PAGEBREAKBEFORE     = (PFM_PAGEBREAKBEFORE  >> 16),     /* (*)  */
        PFE_NOLINENUMBER        = (PFM_NOLINENUMBER     >> 16),     /* (*)  */
        PFE_NOWIDOWCONTROL      = (PFM_NOWIDOWCONTROL   >> 16),     /* (*)  */
        PFE_DONOTHYPHEN         = (PFM_DONOTHYPHEN      >> 16),     /* (*)  */
        PFE_SIDEBYSIDE          = (PFM_SIDEBYSIDE       >> 16),     /* (*)  */

        PFE_TABLEROW            = 0xc000,           /* These 3 options are mutually  */
        PFE_TABLECELLEND        = 0x8000,           /*  exclusive and each imply     */
        PFE_TABLECELL           = 0x4000;           /*  that para is part of a table */
}
