// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface winstrings {
    String LBSELCHSTRINGA = "commdlg_LBSelChangedNotify",
        SHAREVISTRINGA = "commdlg_ShareViolation",
        FILEOKSTRINGA = "commdlg_FileNameOK",
        COLOROKSTRINGA = "commdlg_ColorOK",
        SETRGBSTRINGA = "commdlg_SetRGBColor",
        HELPMSGSTRINGA = "commdlg_help",
        FINDMSGSTRINGA = "commdlg_FindReplace",
        LBSELCHSTRINGW = "commdlg_LBSelChangedNotify",
        SHAREVISTRINGW = "commdlg_ShareViolation",
        FILEOKSTRINGW = "commdlg_FileNameOK",
        COLOROKSTRINGW = "commdlg_ColorOK",
        SETRGBSTRINGW = "commdlg_SetRGBColor",
        HELPMSGSTRINGW = "commdlg_help",
        FINDMSGSTRINGW = "commdlg_FindReplace",
        SZDDESYS_TOPIC = "System",
        SZDDESYS_ITEM_TOPICS = "Topics",
        SZDDESYS_ITEM_SYSITEMS = "SysItems",
        SZDDESYS_ITEM_RTNMSG = "ReturnMessage",
        SZDDESYS_ITEM_STATUS = "Status",
        SZDDESYS_ITEM_FORMATS = "Formats",
        SZDDESYS_ITEM_HELP = "Help",
        SZDDE_ITEM_ITEMLIST = "TopicItemList",
        ALL_TRANSPORTS = "M",
        MS_NBF = "MNBF",
        MS_DEF_PROV_A = "Microsoft Base Cryptographic Provider v1.0",
        MS_DEF_PROV_W = "Microsoft Base Cryptographic Provider v1.0",
        SE_CREATE_TOKEN_NAME = "SeCreateTokenPrivilege",
        SE_ASSIGNPRIMARYTOKEN_NAME = "SeAssignPrimaryTokenPrivilege",
        SE_LOCK_MEMORY_NAME = "SeLockMemoryPrivilege",
        SE_INCREASE_QUOTA_NAME = "SeIncreaseQuotaPrivilege",
        SE_UNSOLICITED_INPUT_NAME = "SeUnsolicitedInputPrivilege",
        SE_MACHINE_ACCOUNT_NAME = "SeMachineAccountPrivilege",
        SE_TCB_NAME = "SeTcbPrivilege",
        SE_SECURITY_NAME = "SeSecurityPrivilege",
        SE_TAKE_OWNERSHIP_NAME = "SeTakeOwnershipPrivilege",
        SE_LOAD_DRIVER_NAME = "SeLoadDriverPrivilege",
        SE_SYSTEM_PROFILE_NAME = "SeSystemProfilePrivilege",
        SE_SYSTEMTIME_NAME = "SeSystemtimePrivilege",
        SE_PROF_SINGLE_PROCESS_NAME = "SeProfileSingleProcessPrivilege",
        SE_INC_BASE_PRIORITY_NAME = "SeIncreaseBasePriorityPrivilege",
        SE_CREATE_PAGEFILE_NAME = "SeCreatePagefilePrivilege",
        SE_CREATE_PERMANENT_NAME = "SeCreatePermanentPrivilege",
        SE_BACKUP_NAME = "SeBackupPrivilege",
        SE_RESTORE_NAME = "SeRestorePrivilege",
        SE_SHUTDOWN_NAME = "SeShutdownPrivilege",
        SE_DEBUG_NAME = "SeDebugPrivilege",
        SE_AUDIT_NAME = "SeAuditPrivilege",
        SE_SYSTEM_ENVIRONMENT_NAME = "SeSystemEnvironmentPrivilege",
        SE_CHANGE_NOTIFY_NAME = "SeChangeNotifyPrivilege",
        SE_REMOTE_SHUTDOWN_NAME = "SeRemoteShutdownPrivilege",
        SPLREG_DEFAULT_SPOOL_DIRECTORY = "DefaultSpoolDirectory",
        SPLREG_PORT_THREAD_PRIORITY_DEFAULT = "PortThreadPriorityDefault",
        SPLREG_PORT_THREAD_PRIORITY = "PortThreadPriority",
        SPLREG_SCHEDULER_THREAD_PRIORITY_DEFAULT = "SchedulerThreadPriorityDefault",
        SPLREG_SCHEDULER_THREAD_PRIORITY = "SchedulerThreadPriority",
        SPLREG_BEEP_ENABLED = "BeepEnabled",
        SPLREG_NET_POPUP = "NetPopup",
        SPLREG_EVENT_LOG = "EventLog",
        SPLREG_MAJOR_VERSION = "MajorVersion",
        SPLREG_MINOR_VERSION = "MinorVersion",
        SPLREG_ARCHITECTURE = "Architecture",
        SERVICES_ACTIVE_DATABASEW = "ServicesActive",
        SERVICES_FAILED_DATABASEW = "ServicesFailed",
        SERVICES_ACTIVE_DATABASEA = "ServicesActive",
        SERVICES_FAILED_DATABASEA = "ServicesFailed",
        WC_HEADERA = "SysHeader32",
        WC_HEADERW = "SysHeader32",
        WC_HEADER = "SysHeader",
        TOOLBARCLASSNAMEW = "ToolbarWindow32",
        TOOLBARCLASSNAMEA = "ToolbarWindow32",
        TOOLBARCLASSNAME = "ToolbarWindow32",
        REBARCLASSNAMEW = "ReBarWindow32",
        REBARCLASSNAMEA = "ReBarWindow32",
        REBARCLASSNAME = "ReBarWindow32",
        TOOLTIPS_CLASSW = "tooltips_class32",
        TOOLTIPS_CLASSA = "tooltips_class32",
        TOOLTIPS_CLASS = "tooltips_class32",
        STATUSCLASSNAMEW = "msctls_statusbar32",
        STATUSCLASSNAMEA = "msctls_statusbar32",
        STATUSCLASSNAME = "msctls_statusbar32",
        TRACKBAR_CLASSA = "msctls_trackbar32",
        TRACKBAR_CLASSW = "msctls_trackbar32",
        TRACKBAR_CLASS = "msctls_trackbar32",
        DRAGLISTMSGSTRING = "commctrl_DragListMsg",
        UPDOWN_CLASSA = "msctls_updown32",
        UPDOWN_CLASSW = "msctls_updown32",
        UPDOWN_CLASS = "msctls_updown32",
        PROGRESS_CLASSA = "msctls_progress32",
        PROGRESS_CLASSW = "msctls_progress32",
        PROGRESS_CLASS = "msctls_progress32",
        HOTKEY_CLASSA = "msctls_hotkey32",
        HOTKEY_CLASSW = "msctls_hotkey32",
        HOTKEY_CLASS = "msctls_hotkey32",
        WC_LISTVIEWA = "SysListView32",
        WC_LISTVIEWW = "SysListView32",
        WC_LISTVIEW = "SysListView32",
        WC_TREEVIEWA = "SysTreeView32",
        WC_TREEVIEWW = "SysTreeView32",
        WC_TREEVIEW = "SysTreeView32",
        WC_COMBOBOXEXW = "ComboBoxEx32",
        WC_COMBOBOXEXA = "ComboBoxEx32",
        WC_COMBOBOXEX = "ComboBoxEx32",
        WC_TABCONTROLA = "SysTabControl32",
        WC_TABCONTROLW = "SysTabControl32",
        WC_TABCONTROL = "SysTabControl32",
        ANIMATE_CLASSW = "SysAnimate32",
        ANIMATE_CLASSA = "SysAnimate32",
        ANIMATE_CLASS = "SysAnimate32",
        MONTHCAL_CLASSW = "SysMonthCal32",
        MONTHCAL_CLASSA = "SysMonthCal32",
        MONTHCAL_CLASS = "SysMonthCal32",
        DATETIMEPICK_CLASSW = "SysDateTimePick32",
        DATETIMEPICK_CLASSA = "SysDateTimePick32",
        DATETIMEPICK_CLASS = "SysDateTimePick32",
        LBSELCHSTRING = "commdlg_LBSelChangedNotify",
        FINDMSGSTRING = "commdlg_FindReplace",
        SHAREVISTRING = "commdlg_ShareViolation",
        SERVICES_FAILED_DATABASE = "ServicesFailed",
        MS_DEF_PROV_ = "Microsoft Base Cryptographic Provider v1.0",
        HELPMSGSTRING = "commdlg_help",
        FILEOKSTRING = "commdlg_FileNameOK",
        SERVICES_ACTIVE_DATABASE = "ServicesActive",
        COLOROKSTRING = "commdlg_ColorOK",
        SETRGBSTRING = "commdlg_SetRGBColor",
        MSH_MOUSEWHEEL = "MSWHEEL_ROLLMSG",
        MSH_SCROLL_LINES = "MSH_SCROLL_LINES_MSG",
        MSH_WHEELSUPPORT = "MSH_WHEELSUPPORT_MSG",
        MOUSEZ_CLASSNAME = "MouseZ",
        MOUSEZ_TITLE = "Magellan MSWHEEL";

    /* RichEdit: clipboard formats - use as parameter to RegisterClipboardFormat() */
    String  CF_RTF          = "Rich Text Format",
            CF_RTFNOOBJS    = "Rich Text Format Without Objects",
            CF_RETEXTOBJ    = "RichEdit Text and Objects";
}
