// (C) Copyright 1995 - 1999 Microsoft Corporation.  All rights reserved.

// These classes provide direct, low-overhead access to commonly used
// Windows api. These classes use the new J/Direct feature.
//
// Information on how to use J/Direct to write your own declarations
// can be found in the Microsoft SDK for Java 2.0 or later.

package com.ms.win32;

public interface winw {
    int WM_DDE_FIRST = 0x03E0,
        WM_DDE_INITIATE = (0x03E0),
        WM_DDE_TERMINATE = (0x03E0+1),
        WM_DDE_ADVISE = (0x03E0+2),
        WM_DDE_UNADVISE = (0x03E0+3),
        WM_DDE_ACK = (0x03E0+4),
        WM_DDE_DATA = (0x03E0+5),
        WM_DDE_REQUEST = (0x03E0+6),
        WM_DDE_POKE = (0x03E0+7),
        WM_DDE_EXECUTE = (0x03E0+8),
        WM_DDE_LAST = (0x03E0+8),
        WAVERR_BASE = 32,
        WAVERR_BADFORMAT = (32+0),
        WAVERR_STILLPLAYING = (32+1),
        WAVERR_UNPREPARED = (32+2),
        WAVERR_SYNC = (32+3),
        WAVERR_LASTERROR = (32+3),
        WOM_OPEN = 0x3BB,
        WOM_CLOSE = 0x3BC,
        WOM_DONE = 0x3BD,
        WIM_OPEN = 0x3BE,
        WIM_CLOSE = 0x3BF,
        WIM_DATA = 0x3C0,
        WAVE_FORMAT_QUERY = 0x0001,
        WAVE_ALLOWSYNC = 0x0002,
        WAVE_MAPPED = 0x0004,
        WAVE_FORMAT_DIRECT = 0x0008,
        WAVE_FORMAT_DIRECT_QUERY = (0x0001|0x0008),
        WHDR_DONE = 0x00000001,
        WHDR_PREPARED = 0x00000002,
        WHDR_BEGINLOOP = 0x00000004,
        WHDR_ENDLOOP = 0x00000008,
        WHDR_INQUEUE = 0x00000010,
        WAVECAPS_PITCH = 0x0001,
        WAVECAPS_PLAYBACKRATE = 0x0002,
        WAVECAPS_VOLUME = 0x0004,
        WAVECAPS_LRVOLUME = 0x0008,
        WAVECAPS_SYNC = 0x0010,
        WAVECAPS_SAMPLEACCURATE = 0x0020,
        WAVECAPS_DIRECTSOUND = 0x0040,
        WAVE_INVALIDFORMAT = 0x00000000,
        WAVE_FORMAT_1M08 = 0x00000001,
        WAVE_FORMAT_1S08 = 0x00000002,
        WAVE_FORMAT_1M16 = 0x00000004,
        WAVE_FORMAT_1S16 = 0x00000008,
        WAVE_FORMAT_2M08 = 0x00000010,
        WAVE_FORMAT_2S08 = 0x00000020,
        WAVE_FORMAT_2M16 = 0x00000040,
        WAVE_FORMAT_2S16 = 0x00000080,
        WAVE_FORMAT_4M08 = 0x00000100,
        WAVE_FORMAT_4S08 = 0x00000200,
        WAVE_FORMAT_4M16 = 0x00000400,
        WAVE_FORMAT_4S16 = 0x00000800,
        WAVE_FORMAT_PCM = 1,
        WIN32 = 100,
        WIZ_CXDLG = 276,
        WIZ_CYDLG = 140,
        WIZ_CXBMP = 80,
        WIZ_BODYX = 92,
        WIZ_BODYCX = 184,
        WIN_CERT_REVISION_1_0 = (0x0100),
        WIN_CERT_TYPE_X509 = (0x0001),
        WIN_CERT_TYPE_PKCS_SIGNED_DATA = (0x0002),
        WIN_CERT_TYPE_RESERVED_1 = (0x0003),
        WINDOW_BUFFER_SIZE_EVENT = 0x0004,
        WINVER = 0x0400,
        WHITEONBLACK = 2,
        WINDING = 2,
        WHITE_BRUSH = 0,
        WHITE_PEN = 6,
        WGL_FONT_LINES = 0,
        WGL_FONT_POLYGONS = 1,
        WGL_SWAP_MAIN_PLANE = 0x00000001,
        WGL_SWAP_OVERLAY1 = 0x00000002,
        WGL_SWAP_OVERLAY2 = 0x00000004,
        WGL_SWAP_OVERLAY3 = 0x00000008,
        WGL_SWAP_OVERLAY4 = 0x00000010,
        WGL_SWAP_OVERLAY5 = 0x00000020,
        WGL_SWAP_OVERLAY6 = 0x00000040,
        WGL_SWAP_OVERLAY7 = 0x00000080,
        WGL_SWAP_OVERLAY8 = 0x00000100,
        WGL_SWAP_OVERLAY9 = 0x00000200,
        WGL_SWAP_OVERLAY10 = 0x00000400,
        WGL_SWAP_OVERLAY11 = 0x00000800,
        WGL_SWAP_OVERLAY12 = 0x00001000,
        WGL_SWAP_OVERLAY13 = 0x00002000,
        WGL_SWAP_OVERLAY14 = 0x00004000,
        WGL_SWAP_OVERLAY15 = 0x00008000,
        WGL_SWAP_UNDERLAY1 = 0x00010000,
        WGL_SWAP_UNDERLAY2 = 0x00020000,
        WGL_SWAP_UNDERLAY3 = 0x00040000,
        WGL_SWAP_UNDERLAY4 = 0x00080000,
        WGL_SWAP_UNDERLAY5 = 0x00100000,
        WGL_SWAP_UNDERLAY6 = 0x00200000,
        WGL_SWAP_UNDERLAY7 = 0x00400000,
        WGL_SWAP_UNDERLAY8 = 0x00800000,
        WGL_SWAP_UNDERLAY9 = 0x01000000,
        WGL_SWAP_UNDERLAY10 = 0x02000000,
        WGL_SWAP_UNDERLAY11 = 0x04000000,
        WGL_SWAP_UNDERLAY12 = 0x08000000,
        WGL_SWAP_UNDERLAY13 = 0x10000000,
        WGL_SWAP_UNDERLAY14 = 0x20000000,
        WGL_SWAP_UNDERLAY15 = 0x40000000,
        WNNC_NET_MSNET = 0x00010000,
        WNNC_NET_LANMAN = 0x00020000,
        WNNC_NET_NETWARE = 0x00030000,
        WNNC_NET_VINES = 0x00040000,
        WNNC_NET_10NET = 0x00050000,
        WNNC_NET_LOCUS = 0x00060000,
        WNNC_NET_SUN_PC_NFS = 0x00070000,
        WNNC_NET_LANSTEP = 0x00080000,
        WNNC_NET_9TILES = 0x00090000,
        WNNC_NET_LANTASTIC = 0x000A0000,
        WNNC_NET_AS400 = 0x000B0000,
        WNNC_NET_FTP_NFS = 0x000C0000,
        WNNC_NET_PATHWORKS = 0x000D0000,
        WNNC_NET_LIFENET = 0x000E0000,
        WNNC_NET_POWERLAN = 0x000F0000,
        WNNC_NET_BWNFS = 0x00100000,
        WNNC_NET_COGENT = 0x00110000,
        WNNC_NET_FARALLON = 0x00120000,
        WNNC_NET_APPLETALK = 0x00130000,
        WNNC_NET_INTERGRAPH = 0x00140000,
        WNNC_NET_SYMFONET = 0x00150000,
        WNNC_NET_CLEARCASE = 0x00160000,
        WNFMT_MULTILINE = 0x01,
        WNFMT_ABBREVIATED = 0x02,
        WNFMT_INENUM = 0x10,
        WNFMT_CONNECTION = 0x20,
        WN_SUCCESS = 0,
        WN_NO_ERROR = 0,
        WN_NOT_SUPPORTED = 50,
        WN_CANCEL = 1223,
        WN_RETRY = 1237,
        WN_NET_ERROR = 59,
        WN_MORE_DATA = 234,
        WN_BAD_POINTER = 487,
        WN_BAD_VALUE = 87,
        WN_BAD_USER = 2202,
        WN_BAD_PASSWORD = 86,
        WN_ACCESS_DENIED = 5,
        WN_FUNCTION_BUSY = 170,
        WN_WINDOWS_ERROR = 59,
        WN_OUT_OF_MEMORY = 8,
        WN_NO_NETWORK = 1222,
        WN_EXTENDED_ERROR = 1208,
        WN_BAD_LEVEL = 124,
        WN_BAD_HANDLE = 6,
        WN_NOT_INITIALIZING = 1247,
        WN_NO_MORE_DEVICES = 1248,
        WN_NOT_CONNECTED = 2250,
        WN_OPEN_FILES = 2401,
        WN_DEVICE_IN_USE = 2404,
        WN_BAD_NETNAME = 67,
        WN_BAD_LOCALNAME = 1200,
        WN_ALREADY_CONNECTED = 85,
        WN_DEVICE_ERROR = 31,
        WN_CONNECTION_CLOSED = 1201,
        WN_NO_NET_OR_BAD_PATH = 1203,
        WN_BAD_PROVIDER = 1204,
        WN_CANNOT_OPEN_PROFILE = 1205,
        WN_BAD_PROFILE = 1206,
        WN_BAD_DEV_TYPE = 66,
        WN_DEVICE_ALREADY_REMEMBERED = 1202,
        WN_NO_MORE_ENTRIES = 259,
        WN_NOT_CONTAINER = 1207,
        WN_NOT_AUTHENTICATED = 1244,
        WN_NOT_LOGGED_ON = 1245,
        WN_NOT_VALIDATED = 1311,
        WNCON_FORNETCARD = 0x00000001,
        WNCON_NOTROUTED = 0x00000002,
        WNCON_SLOWLINK = 0x00000004,
        WNCON_DYNAMIC = 0x00000008,
        WC_DEFAULTCHECK = 0x00000100,
        WC_COMPOSITECHECK = 0x00000200,
        WC_DISCARDNS = 0x00000010,
        WC_SEPCHARS = 0x00000020,
        WC_DEFAULTCHAR = 0x00000040,
        WRITE_DAC = (0x00040000),
        WRITE_OWNER = (0x00080000),
        WIN31_CLASS = 0,
        WH_MIN = (-1),
        WH_MSGFILTER = (-1),
        WH_JOURNALRECORD = 0,
        WH_JOURNALPLAYBACK = 1,
        WH_KEYBOARD = 2,
        WH_GETMESSAGE = 3,
        WH_CALLWNDPROC = 4,
        WH_CBT = 5,
        WH_SYSMSGFILTER = 6,
        WH_MOUSE = 7,
        WH_HARDWARE = 8,
        WH_DEBUG = 9,
        WH_SHELL = 10,
        WH_FOREGROUNDIDLE = 11,
        WH_CALLWNDPROCRET = 12,
        WH_MAX = 12;
    // WH_MAX = 11;
    int WH_MINHOOK = (-1),
        WH_MAXHOOK = 12,
        WINSTA_ENUMDESKTOPS = 0x0001,
        WINSTA_READATTRIBUTES = 0x0002,
        WINSTA_ACCESSCLIPBOARD = 0x0004,
        WINSTA_CREATEDESKTOP = 0x0008,
        WINSTA_WRITEATTRIBUTES = 0x0010,
        WINSTA_ACCESSGLOBALATOMS = 0x0020,
        WINSTA_EXITWINDOWS = 0x0040,
        WINSTA_ENUMERATE = 0x0100,
        WINSTA_READSCREEN = 0x0200,
        WSF_VISIBLE = 0x0001,
        WM_NULL = 0x0000,
        WM_CREATE = 0x0001,
        WM_DESTROY = 0x0002,
        WM_MOVE = 0x0003,
        WM_SIZE = 0x0005,
        WM_ACTIVATE = 0x0006,
        WA_INACTIVE = 0,
        WA_ACTIVE = 1,
        WA_CLICKACTIVE = 2,
        WM_SETFOCUS = 0x0007,
        WM_KILLFOCUS = 0x0008,
        WM_ENABLE = 0x000A,
        WM_SETREDRAW = 0x000B,
        WM_SETTEXT = 0x000C,
        WM_GETTEXT = 0x000D,
        WM_GETTEXTLENGTH = 0x000E,
        WM_PAINT = 0x000F,
        WM_CLOSE = 0x0010,
        WM_QUERYENDSESSION = 0x0011,
        WM_QUIT = 0x0012,
        WM_QUERYOPEN = 0x0013,
        WM_ERASEBKGND = 0x0014,
        WM_SYSCOLORCHANGE = 0x0015,
        WM_ENDSESSION = 0x0016,
        WM_SHOWWINDOW = 0x0018,
        WM_WININICHANGE = 0x001A,
        WM_SETTINGCHANGE = 0x001A,
        WM_DEVMODECHANGE = 0x001B,
        WM_ACTIVATEAPP = 0x001C,
        WM_FONTCHANGE = 0x001D,
        WM_TIMECHANGE = 0x001E,
        WM_CANCELMODE = 0x001F,
        WM_SETCURSOR = 0x0020,
        WM_MOUSEACTIVATE = 0x0021,
        WM_CHILDACTIVATE = 0x0022,
        WM_QUEUESYNC = 0x0023,
        WM_GETMINMAXINFO = 0x0024,
        WM_PAINTICON = 0x0026,
        WM_ICONERASEBKGND = 0x0027,
        WM_NEXTDLGCTL = 0x0028,
        WM_SPOOLERSTATUS = 0x002A,
        WM_DRAWITEM = 0x002B,
        WM_MEASUREITEM = 0x002C,
        WM_DELETEITEM = 0x002D,
        WM_VKEYTOITEM = 0x002E,
        WM_CHARTOITEM = 0x002F,
        WM_SETFONT = 0x0030,
        WM_GETFONT = 0x0031,
        WM_SETHOTKEY = 0x0032,
        WM_GETHOTKEY = 0x0033,
        WM_QUERYDRAGICON = 0x0037,
        WM_COMPAREITEM = 0x0039,
        WM_COMPACTING = 0x0041,
        WM_COMMNOTIFY = 0x0044,
        WM_WINDOWPOSCHANGING = 0x0046,
        WM_WINDOWPOSCHANGED = 0x0047,
        WM_POWER = 0x0048,
        WM_COPYDATA = 0x004A,
        WM_CANCELJOURNAL = 0x004B,
        WM_NOTIFY = 0x004E,
        WM_INPUTLANGCHANGEREQUEST = 0x0050,
        WM_INPUTLANGCHANGE = 0x0051,
        WM_TCARD = 0x0052,
        WM_HELP = 0x0053,
        WM_USERCHANGED = 0x0054,
        WM_NOTIFYFORMAT = 0x0055,
        WM_CONTEXTMENU = 0x007B,
        WM_STYLECHANGING = 0x007C,
        WM_STYLECHANGED = 0x007D,
        WM_DISPLAYCHANGE = 0x007E,
        WM_GETICON = 0x007F,
        WM_SETICON = 0x0080,
        WM_NCCREATE = 0x0081,
        WM_NCDESTROY = 0x0082,
        WM_NCCALCSIZE = 0x0083,
        WM_NCHITTEST = 0x0084,
        WM_NCPAINT = 0x0085,
        WM_NCACTIVATE = 0x0086,
        WM_GETDLGCODE = 0x0087,
        WM_NCMOUSEMOVE = 0x00A0,
        WM_NCLBUTTONDOWN = 0x00A1,
        WM_NCLBUTTONUP = 0x00A2,
        WM_NCLBUTTONDBLCLK = 0x00A3,
        WM_NCRBUTTONDOWN = 0x00A4,
        WM_NCRBUTTONUP = 0x00A5,
        WM_NCRBUTTONDBLCLK = 0x00A6,
        WM_NCMBUTTONDOWN = 0x00A7,
        WM_NCMBUTTONUP = 0x00A8,
        WM_NCMBUTTONDBLCLK = 0x00A9,
        WM_KEYFIRST = 0x0100,
        WM_KEYDOWN = 0x0100,
        WM_KEYUP = 0x0101,
        WM_CHAR = 0x0102,
        WM_DEADCHAR = 0x0103,
        WM_SYSKEYDOWN = 0x0104,
        WM_SYSKEYUP = 0x0105,
        WM_SYSCHAR = 0x0106,
        WM_SYSDEADCHAR = 0x0107,
        WM_KEYLAST = 0x0108,
        WM_IME_STARTCOMPOSITION = 0x010D,
        WM_IME_ENDCOMPOSITION = 0x010E,
        WM_IME_COMPOSITION = 0x010F,
        WM_IME_KEYLAST = 0x010F,
        WM_INITDIALOG = 0x0110,
        WM_COMMAND = 0x0111,
        WM_SYSCOMMAND = 0x0112,
        WM_TIMER = 0x0113,
        WM_HSCROLL = 0x0114,
        WM_VSCROLL = 0x0115,
        WM_INITMENU = 0x0116,
        WM_INITMENUPOPUP = 0x0117,
        WM_MENUSELECT = 0x011F,
        WM_MENUCHAR = 0x0120,
        WM_ENTERIDLE = 0x0121,
        WM_CTLCOLORMSGBOX = 0x0132,
        WM_CTLCOLOREDIT = 0x0133,
        WM_CTLCOLORLISTBOX = 0x0134,
        WM_CTLCOLORBTN = 0x0135,
        WM_CTLCOLORDLG = 0x0136,
        WM_CTLCOLORSCROLLBAR = 0x0137,
        WM_CTLCOLORSTATIC = 0x0138,
        WM_MOUSEFIRST = 0x0200,
        WM_MOUSEMOVE = 0x0200,
        WM_LBUTTONDOWN = 0x0201,
        WM_LBUTTONUP = 0x0202,
        WM_LBUTTONDBLCLK = 0x0203,
        WM_RBUTTONDOWN = 0x0204,
        WM_RBUTTONUP = 0x0205,
        WM_RBUTTONDBLCLK = 0x0206,
        WM_MBUTTONDOWN = 0x0207,
        WM_MBUTTONUP = 0x0208,
        WM_MBUTTONDBLCLK = 0x0209,
        WM_MOUSEWHEEL = 0x020A,
        WM_MOUSELAST = 0x020A;
    int WHEEL_DELTA = 120,
        WM_PARENTNOTIFY = 0x0210,
        WM_ENTERMENULOOP = 0x0211,
        WM_EXITMENULOOP = 0x0212,
        WM_NEXTMENU = 0x0213,
        WM_SIZING = 0x0214,
        WM_CAPTURECHANGED = 0x0215,
        WM_MOVING = 0x0216,
        WM_POWERBROADCAST = 0x0218,
        WM_DEVICECHANGE = 0x0219,
        WM_IME_SETCONTEXT = 0x0281,
        WM_IME_NOTIFY = 0x0282,
        WM_IME_CONTROL = 0x0283,
        WM_IME_COMPOSITIONFULL = 0x0284,
        WM_IME_SELECT = 0x0285,
        WM_IME_CHAR = 0x0286,
        WM_IME_KEYDOWN = 0x0290,
        WM_IME_KEYUP = 0x0291,
        WM_MDICREATE = 0x0220,
        WM_MDIDESTROY = 0x0221,
        WM_MDIACTIVATE = 0x0222,
        WM_MDIRESTORE = 0x0223,
        WM_MDINEXT = 0x0224,
        WM_MDIMAXIMIZE = 0x0225,
        WM_MDITILE = 0x0226,
        WM_MDICASCADE = 0x0227,
        WM_MDIICONARRANGE = 0x0228,
        WM_MDIGETACTIVE = 0x0229,
        WM_MDISETMENU = 0x0230,
        WM_ENTERSIZEMOVE = 0x0231,
        WM_EXITSIZEMOVE = 0x0232,
        WM_DROPFILES = 0x0233,
        WM_MDIREFRESHMENU = 0x0234,
        WM_MOUSEHOVER = 0x02A1,
        WM_MOUSELEAVE = 0x02A3,
        WM_CUT = 0x0300,
        WM_COPY = 0x0301,
        WM_PASTE = 0x0302,
        WM_CLEAR = 0x0303,
        WM_UNDO = 0x0304,
        WM_RENDERFORMAT = 0x0305,
        WM_RENDERALLFORMATS = 0x0306,
        WM_DESTROYCLIPBOARD = 0x0307,
        WM_DRAWCLIPBOARD = 0x0308,
        WM_PAINTCLIPBOARD = 0x0309,
        WM_VSCROLLCLIPBOARD = 0x030A,
        WM_SIZECLIPBOARD = 0x030B,
        WM_ASKCBFORMATNAME = 0x030C,
        WM_CHANGECBCHAIN = 0x030D,
        WM_HSCROLLCLIPBOARD = 0x030E,
        WM_QUERYNEWPALETTE = 0x030F,
        WM_PALETTEISCHANGING = 0x0310,
        WM_PALETTECHANGED = 0x0311,
        WM_HOTKEY = 0x0312,
        WM_PRINT = 0x0317,
        WM_PRINTCLIENT = 0x0318,
        WM_HANDHELDFIRST = 0x0358,
        WM_HANDHELDLAST = 0x035F,
        WM_AFXFIRST = 0x0360,
        WM_AFXLAST = 0x037F,
        WM_PENWINFIRST = 0x0380,
        WM_PENWINLAST = 0x038F,
        WM_APP = 0x8000,
        WM_USER = 0x0400,
        WMSZ_LEFT = 1,
        WMSZ_RIGHT = 2,
        WMSZ_TOP = 3,
        WMSZ_TOPLEFT = 4,
        WMSZ_TOPRIGHT = 5,
        WMSZ_BOTTOM = 6,
        WMSZ_BOTTOMLEFT = 7,
        WMSZ_BOTTOMRIGHT = 8,
        WVR_ALIGNTOP = 0x0010,
        WVR_ALIGNLEFT = 0x0020,
        WVR_ALIGNBOTTOM = 0x0040,
        WVR_ALIGNRIGHT = 0x0080,
        WVR_HREDRAW = 0x0100,
        WVR_VREDRAW = 0x0200,
        WVR_VALIDRECTS = 0x0400,
        WS_OVERLAPPED = 0x00000000,
        WS_POPUP = 0x80000000,
        WS_CHILD = 0x40000000,
        WS_MINIMIZE = 0x20000000,
        WS_VISIBLE = 0x10000000,
        WS_DISABLED = 0x08000000,
        WS_CLIPSIBLINGS = 0x04000000,
        WS_CLIPCHILDREN = 0x02000000,
        WS_MAXIMIZE = 0x01000000,
        WS_CAPTION = 0x00C00000,
        WS_BORDER = 0x00800000,
        WS_DLGFRAME = 0x00400000,
        WS_VSCROLL = 0x00200000,
        WS_HSCROLL = 0x00100000,
        WS_SYSMENU = 0x00080000,
        WS_THICKFRAME = 0x00040000,
        WS_GROUP = 0x00020000,
        WS_TABSTOP = 0x00010000,
        WS_MINIMIZEBOX = 0x00020000,
        WS_MAXIMIZEBOX = 0x00010000,
        WS_TILED = 0x00000000,
        WS_ICONIC = 0x20000000,
        WS_SIZEBOX = 0x00040000,
        WS_OVERLAPPEDWINDOW = (0x00000000|0x00C00000|0x00080000|0x00040000|0x00020000|0x00010000),
        WS_POPUPWINDOW = (0x80000000|0x00800000|0x00080000),
        WS_CHILDWINDOW = (0x40000000),
        WS_EX_DLGMODALFRAME = 0x00000001,
        WS_EX_NOPARENTNOTIFY = 0x00000004,
        WS_EX_TOPMOST = 0x00000008,
        WS_EX_ACCEPTFILES = 0x00000010,
        WS_EX_TRANSPARENT = 0x00000020,
        WS_EX_MDICHILD = 0x00000040,
        WS_EX_TOOLWINDOW = 0x00000080,
        WS_EX_WINDOWEDGE = 0x00000100,
        WS_EX_CLIENTEDGE = 0x00000200,
        WS_EX_CONTEXTHELP = 0x00000400,
        WS_EX_RIGHT = 0x00001000,
        WS_EX_LEFT = 0x00000000,
        WS_EX_RTLREADING = 0x00002000,
        WS_EX_LTRREADING = 0x00000000,
        WS_EX_LEFTSCROLLBAR = 0x00004000,
        WS_EX_RIGHTSCROLLBAR = 0x00000000,
        WS_EX_CONTROLPARENT = 0x00010000,
        WS_EX_STATICEDGE = 0x00020000,
        WS_EX_APPWINDOW = 0x00040000,
        WS_EX_OVERLAPPEDWINDOW = (0x00000100|0x00000200),
        WS_EX_PALETTEWINDOW = (0x00000100|0x00000080|0x00000008),
        WPF_SETMINPOSITION = 0x0001,
        WPF_RESTORETOMAXIMIZED = 0x0002,
        WB_LEFT = 0,
        WB_RIGHT = 1,
        WB_ISDELIMITER = 2,
        WDT_INPROC_CALL = (0x48746457),
        WDT_REMOTE_CALL = (0x52746457),
        WM_CHOOSEFONT_GETLOGFONT = (0x0400+1),
        WM_PSD_PAGESETUPDLG = (0x0400),
        WM_PSD_FULLPAGERECT = (0x0400+1),
        WM_PSD_MINMARGINRECT = (0x0400+2),
        WM_PSD_MARGINRECT = (0x0400+3),
        WM_PSD_GREEKTEXTRECT = (0x0400+4),
        WM_PSD_ENVSTAMPRECT = (0x0400+5),
        WM_PSD_YAFULLPAGERECT = (0x0400+6),
        WAIT_IO_COMPLETION = (0x000000C0),
        WS_TILEDWINDOW = (0x00000000|0x00C00000|0x00080000|0x00040000|0x00020000|0x00010000);
    int WAIT_OBJECT_0 = 0x00000000,
        WAIT_FAILED = 0xFFFFFFFF,
        WAIT_TIMEOUT = 0x00000102,
        WAIT_ABANDONED = 0x00000080,
        WAIT_ABANDONED_0 = WAIT_ABANDONED,
        WHITENESS = 0x00FF0062;

    /* RichEdit: new word break function actions */
    int WB_CLASSIFY         = 3,
        WB_MOVEWORDLEFT     = 4,
        WB_MOVEWORDRIGHT    = 5,
        WB_LEFTBREAK        = 6,
        WB_RIGHTBREAK       = 7;

    /* RichEdit: Far East specific flags */
    int WB_MOVEWORDPREV     = 4,
        WB_MOVEWORDNEXT     = 5,
        WB_PREVBREAK        = 6,
        WB_NEXTBREAK        = 7,
        WBF_WORDWRAP        = 0x010,
        WBF_WORDBREAK       = 0x020,
        WBF_OVERFLOW        = 0x040,
        WBF_LEVEL1          = 0x080,
        WBF_LEVEL2          = 0x100,
        WBF_CUSTOM          = 0x200;

    /* RichEdit: Word break flags (used with WB_CLASSIFY) */
    int WBF_CLASS           = 0x0F,
        WBF_ISWHITE         = 0x10,
        WBF_BREAKLINE       = 0x20,
        WBF_BREAKAFTER      = 0x40;
        
    /* RichEdit: UNICODE embedding character */
    char WCH_EMBEDDING      = 0xFFFC;
}
